//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: cosmos/evidence/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service.
///
/// Usage: instantiate `Cosmos_Evidence_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Cosmos_Evidence_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Cosmos_Evidence_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func evidence(
    _ request: Cosmos_Evidence_V1beta1_QueryEvidenceRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Evidence_V1beta1_QueryEvidenceRequest, Cosmos_Evidence_V1beta1_QueryEvidenceResponse>

  func allEvidence(
    _ request: Cosmos_Evidence_V1beta1_QueryAllEvidenceRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Evidence_V1beta1_QueryAllEvidenceRequest, Cosmos_Evidence_V1beta1_QueryAllEvidenceResponse>
}

extension Cosmos_Evidence_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "cosmos.evidence.v1beta1.Query"
  }

  /// Evidence queries evidence based on evidence hash.
  ///
  /// - Parameters:
  ///   - request: Request to send to Evidence.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func evidence(
    _ request: Cosmos_Evidence_V1beta1_QueryEvidenceRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Evidence_V1beta1_QueryEvidenceRequest, Cosmos_Evidence_V1beta1_QueryEvidenceResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.evidence.v1beta1.Query/Evidence",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeEvidenceInterceptors() ?? []
    )
  }

  /// AllEvidence queries all evidence.
  ///
  /// - Parameters:
  ///   - request: Request to send to AllEvidence.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func allEvidence(
    _ request: Cosmos_Evidence_V1beta1_QueryAllEvidenceRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Evidence_V1beta1_QueryAllEvidenceRequest, Cosmos_Evidence_V1beta1_QueryAllEvidenceResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.evidence.v1beta1.Query/AllEvidence",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAllEvidenceInterceptors() ?? []
    )
  }
}

internal protocol Cosmos_Evidence_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'evidence'.
  func makeEvidenceInterceptors() -> [ClientInterceptor<Cosmos_Evidence_V1beta1_QueryEvidenceRequest, Cosmos_Evidence_V1beta1_QueryEvidenceResponse>]

  /// - Returns: Interceptors to use when invoking 'allEvidence'.
  func makeAllEvidenceInterceptors() -> [ClientInterceptor<Cosmos_Evidence_V1beta1_QueryAllEvidenceRequest, Cosmos_Evidence_V1beta1_QueryAllEvidenceResponse>]
}

internal final class Cosmos_Evidence_V1beta1_QueryClient: Cosmos_Evidence_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Cosmos_Evidence_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the cosmos.evidence.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Cosmos_Evidence_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Cosmos_Evidence_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Cosmos_Evidence_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// Evidence queries evidence based on evidence hash.
  func evidence(request: Cosmos_Evidence_V1beta1_QueryEvidenceRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Evidence_V1beta1_QueryEvidenceResponse>

  /// AllEvidence queries all evidence.
  func allEvidence(request: Cosmos_Evidence_V1beta1_QueryAllEvidenceRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Evidence_V1beta1_QueryAllEvidenceResponse>
}

extension Cosmos_Evidence_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "cosmos.evidence.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Evidence":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Evidence_V1beta1_QueryEvidenceRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Evidence_V1beta1_QueryEvidenceResponse>(),
        interceptors: self.interceptors?.makeEvidenceInterceptors() ?? [],
        userFunction: self.evidence(request:context:)
      )

    case "AllEvidence":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Evidence_V1beta1_QueryAllEvidenceRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Evidence_V1beta1_QueryAllEvidenceResponse>(),
        interceptors: self.interceptors?.makeAllEvidenceInterceptors() ?? [],
        userFunction: self.allEvidence(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Cosmos_Evidence_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'evidence'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeEvidenceInterceptors() -> [ServerInterceptor<Cosmos_Evidence_V1beta1_QueryEvidenceRequest, Cosmos_Evidence_V1beta1_QueryEvidenceResponse>]

  /// - Returns: Interceptors to use when handling 'allEvidence'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAllEvidenceInterceptors() -> [ServerInterceptor<Cosmos_Evidence_V1beta1_QueryAllEvidenceRequest, Cosmos_Evidence_V1beta1_QueryAllEvidenceResponse>]
}
